<?php

/**
 * Plugin Name:       MF Url list
 * Plugin URI:        https://www.mario-flores.com/mf-manager/
 * Description:       Show all urls in the database
 * Version:           5.0.0
 * Requires at least: 5.2
 * Requires PHP:      5.6
 * Author:            Mario Flores
 * Author URI:        https://mario-flores.com
 * License:           GPL v2 or later
 * License URI:       https://www.gnu.org/licenses/gpl-2.0.html
 * Text Domain:       mf_urllist
 * Domain Path:       /languages
 */

add_action('admin_menu', 'mf_list_urls_menu');
function mf_list_urls_menu()
{
    add_menu_page(
        'MF Url list',
        'MF Url list',
        'manage_options',
        'mf_url_list_page',
        'mf_url_list'
    );
}

function mf_url_list()
{
    global $wpdb;
    $prefix =  $wpdb->get_blog_prefix();
    $tables = $wpdb->tables;
    $columns = array();
    $urls = array(); 
    foreach ($tables as $table) {
        $table_data = $wpdb->get_results("select column_name, data_type from information_schema.columns where table_schema = '" . DB_NAME . "' and table_name = '" . $prefix . $table . "' ");
        $columns = array();
        foreach ($table_data as $data) {
            if ($data->data_type == 'longtext' or $data->data_type == 'text' or $data->data_type == 'varchar') {
                $columns[] = $data->column_name;
            }
        }
        if(!empty($columns)){
            $texts = $wpdb->get_results("select " . implode(',', $columns) . " from " . $prefix . $table);
            foreach ($texts as $text) {
                foreach ($columns as $column) {
                    $needle = "http";
                    $lastPos = 0;
                    $positions = array();
                    while (($lastPos = strpos($text->{$column}, $needle, $lastPos)) !== false) {
                        $positions[] = $lastPos;
                        $lastPos = $lastPos + strlen($needle);
                    }
                    foreach($positions as $p){
                        $url = strip_tags(substr($text->{$column}, $p, 100)); 
                        if(!str_contains($url, 'wordpress.org')){
                            $urls[] = $url;  
                        }
                        
                    }
                }
            }
        }
    }
    sort($urls); 
    echo '<div class="mf-url-list-wrapper">';

    echo '<h2>List of URLs found in database:</h2>';
    
    if (!empty($urls)) {
        foreach ($urls as $url) {
            echo '<div class="mf-url-item">' . esc_html($url) . '</div>';
        }
    } else {
        echo '<p>No URLs found.</p>';
    }

    echo '</div>'; // end of div wrapper
}
